wxLZMAInputStream Class Reference | wxWidgets

| Version: 3.2.11

Loading...
Searching...
No Matches
Public Member Functions | List of all members
wxLZMAInputStream Class Reference
Class List by Category » Archive support | Class List by Category » Streams

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.2/wxWidgets3.2-3.2.11-1.x86_64/src/wxWidgets-3.2.11/interface/wx/lzmastream.h>`

Inheritance diagram for wxLZMAInputStream:
[legend]

## Detailed Description

This filter stream decompresses data in XZ format.

XZ format uses LZMA2 algorithm for compression used for .xz files and is similar to GZip or BZip2 format. Notice that it is different from, and incompatible with, 7z archive format even although it uses the same compression algorithm.

To decompress contents of standard input to standard output, the following (not optimally efficient) code could be used:

wxFFileInputStream fin(stdin);
wxLZMAInputStream zin(fin);
wxFFileOutputStream fout(stdout);
zin.Read(fout);
if ( zin.GetLastError() != wxSTREAM_EOF ) {
... handle error ...
}
wxFFileInputStream
This class represents data read in from a file.
Definition wfstream.h:284
wxFFileOutputStream
This class represents data written to a file.
Definition wfstream.h:118
wxLZMAInputStream::wxLZMAInputStream
wxLZMAInputStream(wxInputStream &stream)
Create decompressing stream associated with the given underlying stream.
wxSTREAM_EOF
@ wxSTREAM_EOF
EOF reached in Read() or similar.
Definition stream.h:16

See Using LZMA compression with liblzma for information about liblzma, required in order to use this class.

##

Library: wxBase
Category: Archive support, Streams

See also
  wxInputStream, wxZlibInputStream, wxLZMAOutputStream.

Since
  3.1.2

## Public Member Functions
| wxLZMAInputStream (wxInputStream &stream)
| Create decompressing stream associated with the given underlying stream.
| wxLZMAInputStream (wxInputStream *stream)
| Create decompressing stream associated with the given underlying stream and takes ownership of it.
Public Member Functions inherited from wxFilterInputStream
| wxFilterInputStream (wxInputStream &stream)
| Initializes a "filter" stream.
| wxFilterInputStream (wxInputStream *stream)
| Initializes a "filter" stream.
Public Member Functions inherited from wxInputStream
| wxInputStream ()
| Creates a dummy input stream.
virtual | ~wxInputStream ()
| Destructor.
virtual bool | CanRead () const
| Returns true if some data is available in the stream right now, so that calling Read() wouldn't block.
virtual bool | Eof () const
| Returns true after an attempt has been made to read past the end of the stream.
int | GetC ()
| Returns the first character in the input queue and removes it, blocking until it appears if necessary.
virtual size_t | LastRead () const
| Returns the last number of bytes read.
virtual char | Peek ()
| Returns the first character in the input queue without removing it.
virtual wxInputStream & | Read (void *buffer, size_t size)
| Reads the specified amount of bytes and stores the data in buffer.
wxInputStream & | Read (wxOutputStream &stream_out)
| Reads data from the input queue and stores it in the specified output stream.
bool | ReadAll (void *buffer, size_t size)
| Reads exactly the specified number of bytes into the buffer.
virtual wxFileOffset | SeekI (wxFileOffset pos, wxSeekMode mode=wxFromStart)
| Changes the stream current position.
virtual wxFileOffset | TellI () const
| Returns the current stream position or wxInvalidOffset if it's not available (e.g.
size_t | Ungetch (const void *buffer, size_t size)
| This function is only useful in read mode.
bool | Ungetch (char c)
| This function acts like the previous one except that it takes only one character: it is sometimes shorter to use than the generic function.
Public Member Functions inherited from wxStreamBase
| wxStreamBase ()
| Creates a dummy stream object.
virtual | ~wxStreamBase ()
| Destructor.
wxStreamError | GetLastError () const
| This function returns the last error.
virtual wxFileOffset | GetLength () const
| Returns the length of the stream in bytes.
virtual size_t | GetSize () const
| This function returns the size of the stream.
virtual bool | IsOk () const
| Returns true if no error occurred on the stream.
virtual bool | IsSeekable () const
| Returns true if the stream supports seeking to arbitrary offsets.
void | Reset (wxStreamError error=wxSTREAM_NO_ERROR)
| Resets the stream state.
bool | operator! () const
| Returns the opposite of IsOk().

## Additional Inherited Members
Protected Member Functions inherited from wxInputStream
size_t | OnSysRead (void *buffer, size_t bufsize)=0
| Internal function.
Protected Member Functions inherited from wxStreamBase
virtual wxFileOffset | OnSysSeek (wxFileOffset pos, wxSeekMode mode)
| Internal function.
virtual wxFileOffset | OnSysTell () const
| Internal function.

## Constructor & Destructor Documentation

## ◆ wxLZMAInputStream() [1/2]

wxLZMAInputStream::wxLZMAInputStream | ( | wxInputStream & | stream | ) |

Create decompressing stream associated with the given underlying stream.

This overload does not take ownership of the stream.

## ◆ wxLZMAInputStream() [2/2]

wxLZMAInputStream::wxLZMAInputStream | ( | wxInputStream * | stream | ) |

Create decompressing stream associated with the given underlying stream and takes ownership of it.

As with the base wxFilterInputStream class, passing stream by pointer indicates that this object takes ownership of it and will delete it when it is itself destroyed.